﻿

RT_Button = {
	EscapeToChar = {
		["\194\161"] = "!",	["\194\170"] = "a", ["\194\186"] = "o", ["\194\191"] = "?", ["\195\128"] = "A", ["\195\129"] = "A",
		["\195\130"] = "A", ["\195\131"] = "A", ["\195\133"] = "A", ["\195\135"] = "C", ["\195\136"] = "E", ["\195\137"] = "E",
		["\195\138"] = "E", ["\195\139"] = "E", ["\195\140"] = "I", ["\195\141"] = "I", ["\195\142"] = "I", ["\195\143"] = "I",
		["\195\144"] = "D", ["\195\145"] = "N", ["\195\146"] = "O", ["\195\147"] = "O", ["\195\148"] = "O", ["\195\149"] = "O",
		["\195\152"] = "O", ["\195\153"] = "U", ["\195\154"] = "U", ["\195\155"] = "U", ["\195\157"] = "Y", ["\195\160"] = "a",
		["\195\161"] = "a", ["\195\162"] = "a", ["\195\163"] = "a", ["\195\165"] = "a", ["\195\167"] = "c", ["\195\168"] = "e",
		["\195\169"] = "e", ["\195\170"] = "e", ["\195\171"] = "e", ["\195\172"] = "i", ["\195\173"] = "i", ["\195\174"] = "i",
		["\195\175"] = "i", ["\195\176"] = "d", ["\195\177"] = "n", ["\195\178"] = "o", ["\195\179"] = "o", ["\195\180"] = "o",
		["\195\181"] = "o", ["\195\184"] = "o", ["\195\185"] = "u", ["\195\186"] = "u", ["\195\187"] = "u", ["\195\189"] = "y",
		["\195\191"] = "y", ["\195\132"] = "Ae", ["\195\134"] = "AE", ["\195\150"] = "Oe", ["\195\156"] = "Ue", ["\195\158"] = "TH",
		["\195\159"] = "ss", ["\195\164"] = "ae", ["\195\166"] = "ae", ["\195\182"] = "oe", ["\195\188"] = "ue", ["\195\190"] = "th",
	},
	QuickLooter = { "disenchant", "bank" },
	addItemInfo = { func = nil, value = { }, },
	funcMenuOnClick	= function( frame ) RT_Button:Menu_OnClick(frame) end,
}


function RT_Button:AddMenuItem( level, onClick, type1, what, title, text, value, checked, hasArrow )
	if onClick == nil then onClick = 1 end; 
	if type(onClick)=="boolean" then onClick = (onClick == true) and 1 or nil end
	local e = type(onClick)
	value = (type(value)=="table") and value or { value = value };	
	local info = self.addItemInfo
	if info.value then
		for i,v in pairs(info.value) do
			if not value[i] then value[i] = v end
		end
	end
	
	info.text = title .. (text and (" ("..text..")") or "")
	info.func = (e == "function") and onClick or (onClick and self.funcMenuOnClick)
	info.checked = checked and 1 or nil
	info.hasArrow = hasArrow and 1 or nil
	info.keepShownOnClick = (hasArrow and e ~= "string") and 1 or nil
   	value.type = (type1) and type1 or value.type
   	value.what = (what) and what or value.what
   	value.title = title
   	value.frameName = (e == "string") and onClick or nil

	info.value, value = value, info.value
	UIDropDownMenu_AddButton(info, level)
	info.value = value
end


-- ************** menus **************

function RT_Button:Menu_Toggle( frame )
	local dropdown = getglobal(frame:GetName().."RightClickMenu")
	if not dropdown then return end
	dropdown.point = "TOPLEFT"
	dropdown.relativePoint = "BOTTOMLEFT"
	ToggleDropDownMenu(1, nil, dropdown, "cursor", 0, 0)
end

function RT_Button:Menu_OnClick( frame )
	local value = frame.value
	if not value then return end
	RaidTracker:DebugTable("RT_Button:Menu_OnClick", frame:GetName(), frame.value )
	if value.frameName then
		RT_Dialog:Show(value.frameName, value.type, value.what, value.raidid, value.itemid, value.player, value.zone, value.boss)
	else
		if value.type == "rarity" then
			KARaidTrackerDB.SortOptions[ RaidTrackerFrame.type .. "filter" ] = frame:GetID()
			KA_RaidTracker_UpdateView( )
		else
			RT_Dialog:Edit_OnSave( value )
		end
		HideDropDownMenu(2)
	end
end


function RT_Button:DetailFrameItems_RarityDropdown_Update( )
	local id = KARaidTrackerDB.SortOptions[ RaidTrackerFrame.type .. "filter" ]
	UIDropDownMenu_SetSelectedID( RT_RarityDropdownFrame, id )
	RT_RarityDropdownFrameText:SetText( RT_Options.desc.rarity[ id ] )
end

function RT_DetailFrameItems_RarityDropdown_Initialize( frame, level )
	for i = 1, #RT_Options.desc.rarity do
		RT_Button:AddMenuItem( nil, nil, "rarity", nil, RT_Options.desc.rarity[i] )
	end
end
		
function RT_RaidItemTemplate_RightClickMenu_Initialize( frame, level )
	if not level then return end
	local db, o, L = RaidTracker._db, RaidTracker._options, RaidTracker.L
	local raidid = frame.GetParent and frame:GetParent().raidid
	local raid = db.Log[raidid]
	if not raid then return end
	--RaidTracker:Debug("level("..level..")", frame:GetName(), raidid);	
	
	if level == 1 then
		RT_Button.addItemInfo.value = { raidid = raidid }
		local value = RT_Button.addItemInfo.value
		
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "time", "raidstart",L["Edit Start"], RaidTracker:GetDisplayDate(raid.key))
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "time", "raidend", L["Edit End"],	RaidTracker:GetDisplayDate(raid.End) or L["none"])
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "zone", nil, L["Edit Zone"], L[raid.zone] or L["none"], nil, db.Zones[raid.zone], true )
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "note", "raid", L["Edit Note"], raid.note )
		RT_Button:AddMenuItem( level, "RT_ExportFrame", "export", nil, L["Show Export String"] )
		
	elseif level == 2 then
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end

		if value.type == "zone" then
			for k, v in ipairs(RaidTracker_GameReleases) do
				checked = nil
				for k1, v1 in pairs(RaidTracker_Zones) do
					if v1.rel == v and k1 == raid.zone then checked = true; end
				end
				RT_Button:AddMenuItem( level, false, nil, nil, L[RaidTracker_Tags["REL"..v]], nil, v, checked, true )
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level )
			for k, v in pairs(db.Zones) do
				RT_Button:AddMenuItem( level, true, nil, nil, L[k], nil, k, raid.zone == k )
			end
			RT_Button:AddMenuItem( level, true, nil, nil, L["None"], nil, nil, raid.zone == nil)
		end
		
	elseif level == 3 then
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end

		if value.type == "zone" then
			local zones = { }
			for k, v in pairs(RaidTracker_Zones) do
				if value.value == v.rel then tinsert( zones, v ); end
			end
			table.sort(zones, function(a, b) return a.pid < b.pid; end)
			for k, v in pairs(zones) do
				local title = L[v.name] .. (v.ran and (o.Color.."  ("..v.ran..")|r") or "")
				RT_Button:AddMenuItem(level, true, nil, nil, title, nil, v.name, raid.zone == v.name)
			end
		end
	end
end

function RT_ItemsLineTemplate_RightClickMenu_Initialize( frame, level )
	if not level then return end;	
	local db, o, L = RaidTracker._db, RaidTracker._options, RaidTracker.L
	local raidid = frame.GetParent and frame:GetParent().raidid
	local itemid = frame.GetParent and frame:GetParent().itemid
	local raid = db.Log[raidid]
	if not raid then return end
	local item = itemid and raid.Loot[itemid] or nil
	local itemiid = RT_ItemOptions:GetItemIid(item and item.item.id or "")
	--RaidTracker:Debug("level("..level..")", raidid, itemid)

	local checked = nil

	if level == 1 then
		RT_Button.addItemInfo.value = { raidid=raidid, itemid=itemid }
		local value = RT_Button.addItemInfo.value

		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "looter", nil, L["Edit Looter"], item.player, nil, nil, true )
		RT_Button:AddMenuItem( level, "RT_EditCostFrame", "itemcost", nil, L["Edit Cost"], item.costs )
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "itemcount", nil, L["Edit Count"], ((item.item.count) and item.item.count or 1) )
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "time", "itemtime", L["Edit Time"], RaidTracker:GetDisplayDate(item.time) or L["none"] )
		RT_Button:AddMenuItem( level, "RT_ItemOptionsFrame", "itemopt", nil, L["Edit Item Options"], itemiid or L["none"], { itemid=item.item.id }, db.ItemOptions[itemiid] )
		RT_Button:AddMenuItem( level, "RT_EditNoteFrame", "boss", "item", L["Dropped from"]..":", item.boss or L["none"], nil, item.boss, true )
		
	elseif level == 2 then	
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end

		if value.type == "looter" then
			for k, v in pairs(RT_Button.QuickLooter) do
				RT_Button:AddMenuItem( level, true, nil, nil, L[v], nil,  v, item.player == v )
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level )
			local g,gi,sg,chk = { },{ },{ }
			for k, v in pairs(raid.Join) do
				RaidTracker:TableAddUnique(gi, v.player)
			end
			table.sort(gi)
			for k, v in pairs(gi) do													-- hash the list by first letter
				local s = (RT_Button.EscapeToChar[v:sub(1, 2)] or v):sub(1,1):upper()	-- if a special char get that
				if not g[s] then g[s] = { } end
				tinsert(g[s], v)
				if item.player == v then chk = s; break end
			end
			for k, v in pairs(g) do	tinsert(sg, k) end
			table.sort(sg)
			for k, v in pairs(sg) do
				RT_Button:AddMenuItem( level, false, nil, nil, v, nil, { players=g[v] }, chk==v, true )
			end
		elseif value.type == "boss" then
			RT_Button:AddMenuItem( level, true, nil, nil, L["None"], nil, nil, item.boss == nil )
			for k, v in pairs(RaidTracker_Bosses) do
				if type(v) ~= "table" then
					RT_Button:AddMenuItem( level, true, nil, nil, L[k], nil, k, item.boss == k )
				end
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level )
			for i,v in pairs(RaidTracker_GameReleases) do
				checked = nil
				if item.boss then
					for k1,v1 in pairs(RaidTracker_Zones) do
						if v1.rel == v and RaidTracker_Bosses[k1] then 
							for k2,v2 in pairs(RaidTracker_Bosses[k1]) do
								if item.boss == v2 then checked = 1; break; end
							end
						end
					end
				end
				RT_Button:AddMenuItem( level, false, nil, nil, L[RaidTracker_Tags["REL"..v]], nil,  v, checked, true )
			end
		end

	elseif level == 3 then
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end

		if value.type == "looter" then
			for k, v in pairs(value.players) do
				RT_Button:AddMenuItem( level, true, nil, nil, v, nil, v, item.player == v )
			end
		elseif value.type == "boss" then
			local zones = { }
			for k, v in pairs(RaidTracker_Zones) do
				if value.value == v.rel then tinsert( zones, v ); end
			end
			table.sort(zones, function(a, b) return a.pid < b.pid; end)
			for k, v in pairs(zones) do
				checked = nil
				if item.boss and RaidTracker_Bosses[v.name] then 
					for k1, v1 in pairs(RaidTracker_Bosses[v.name]) do
						if item.boss == v1 then checked = 1; break; end
					end
				end
				RT_Button:AddMenuItem( level, false, nil, nil, L[v.name], nil,  v.name, checked, true )
			end
		end
	
	elseif level == 4 then
		RT_Button.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Button.addItemInfo.value
		if not value then return end
	
		if value.type == "boss" then
			for k, v in pairs(RaidTracker_Bosses[value.value]) do
				if type(v) ~= "table" then
					RT_Button:AddMenuItem( level, true, nil, nil, L[v], nil,  v, item.boss == v )
				else
					for k2, v2 in pairs(v) do
						RT_Button:AddMenuItem( level, true, nil, nil, L[k], L[v2],  v2, item.boss == v2 )
					end
				end
			end
		end
	end
		
end


-- Next Boss selection handling
function RT_EditBossFrame_Menu_Initialize( frame, level )
	if not level then return end
	local db, o, L = RaidTracker._db, RaidTracker._options, RaidTracker.L
	local raidid = o.CurrentRaid
	local raid = db.Log[raidid]
	if not raid then return end
	--RaidTracker:Debug("level("..level..")", frame:GetName(), raidid);	

	local i = 0
	local ii = 0

	i = KA_RaidTracker_Boss_Add_Button( db.Bosses["DEFAULTBOSS"], i )
	ii = ii + 1
	
	-- no zone, just add bosses from bosses list
	if raid.zone == nil then
		for k,v in pairs(RaidTracker_Bosses) do
			if v == 1 then
				ii = ii + 1
				for k2,v2 in pairs(RaidTracker_BossTriggers) do			-- there are none marked with 1 so will never happen.. was supposed to be world boss?
					if v2 == v then
						i = KA_RaidTracker_Boss_Add_Button(k2,i)
					end
				end
			end
		end
	else
		for k,v in pairs(RaidTracker_Bosses[raid.zone] or { }) do
			local found
			for k2,v2 in pairs(raid.Events) do
				if v2.boss == v then found = true; break end
			end
			if not found then
				if type(v) == "string" then
					ii = ii + 1
					for k2,v2 in pairs(RaidTracker_BossTriggers) do
						if v == v2 then
							i = KA_RaidTracker_Boss_Add_Button(k2,i)
						end
					end
				elseif type(v) == "table" then
					for k2,v2 in pairs(v) do
						ii = ii + 1
						for k3,v3 in pairs(RaidTracker_BossTriggers) do
							if v3 == v2 then
								i = KA_RaidTracker_Boss_Add_Button(k.." - "..k3,i)
							end
						end
					end
				end
			end
		end
	end
	if ii == 2 then
		UIDropDownMenu_SetSelectedID(RT_EditBossFrameMenu, ii)
	end
	
end

function KA_RaidTracker_Boss_Add_Button(k,i)
	local info = {
		text = k,
		func = KA_RaidTracker_Boss_Update,
	}
	UIDropDownMenu_AddButton(info)
	if i == cur_class_id then
		UIDropDownMenu_SetSelectedID(RT_EditBossFrameMenu, i+1)
		UIDropDownMenu_SetText(info.text, RT_EditBossFrameMenu)
	end
	return i
end

function KA_RaidTracker_Boss_Update( frame )
	id = this:GetID()
	UIDropDownMenu_SetSelectedID( RT_EditBossFrameMenu, id )
end


function RT_Button:OnUpdate( frame, parent )
	if frame.hasItem and GameTooltip:IsOwned(frame) then
		self:OnEnter(frame, parent)
	end
end

function RT_Button:OnClick( frame, parent, button )
	parent = parent or frame:GetParent()
	local frameName

	if frame.hasItem and self:ShowLinkTooptip(frame, parent, button) then return true end
	if button == "LeftButton" then
		if frame.type == "hit" then
			KA_RaidTracker_Select(parent, parent.type)
		elseif frame.type == "editio" then
			RT_Dialog:Show("RT_ItemOptionsFrame", "itemopt", nil, nil, parent.loot.item.id)
		elseif frame.type == "delete" then
			frameName = "RT_ConfirmDeleteFrame"
		elseif frame.type == "note" then 
			frameName = "RT_EditNoteFrame"
		else
			KA_RaidTracker_Select(parent, frame.type)
			if frame.type == "raid" then
				RaidTrackerFrame.LastPage = { }
				RaidTrackerFrameBackButton:Disable()
			end
		end
	elseif button == "RightButton" then
		self:Menu_Toggle(parent)
	end
			
	if frameName then
		RT_Dialog:Show(frameName, frame.type, parent.type, parent.raidid, parent.itemid, parent.playerid ); 
	end
end

function RT_Button:OnEnter( frame, parent )
	parent = parent or frame:GetParent()
	local title, text, f

	if frame.type == "delete" then
		title = "Click to delete"
	elseif frame.type == "note" then 
		title = "Click to edit note"
		local raid = KARaidTrackerDB.Log[parent.raidid]
		if		parent.type == "item"	then item = raid.Loot[parent.itemid]
		elseif	parent.type == "player"	then item = raid.Players[parent.playerid] end
		text = item and item.note
	else
		f = frame.type and getglobal(parent:GetName().."MouseOver_"..frame.type) or nil
		if f then f:Show() end		
	end	

	f = getglobal(parent:GetName().."MouseOver"); if f then f:Show() end
	
	if frame.hasItem then
		self:ShowLinkTooptip(frame, parent)
		CursorUpdate(frame)
	end

	if title then
		f = GameTooltip
		f:SetOwner(frame, "ANCHOR_RIGHT")
		f:ClearLines()
		f:AddLine(title)
		if text then f:AddLine(text, 0.9, 0.9, 0.9, 1) end
		f:Show()
	end
end

function RT_Button:OnLeave( frame, parent )
	parent = parent or frame:GetParent()
		
	local f = frame.type and getglobal(parent:GetName() .. "MouseOver_"..frame.type); if f then f:Hide() end	
	if not parent.selected then
		f = getglobal(parent:GetName() .. "MouseOver"); if f then f:Hide() end
	end

	if frame.hasItem then
		ResetCursor()
	end
    GameTooltip:Hide()
end

function RT_Button:OnShow( frame, parent )
	parent = parent or frame:GetParent()

	if parent.selected then
		local f = getglobal(parent:GetName() .. "MouseOver"); if f then f:Show() end
	end
end

function RT_Button:ShowLinkTooptip( frame, parent, button )
	if not frame or not parent then return end
	local loot = parent.loot
	local item = parent.item or (loot and loot.item)
	if not item then return end

	local L = RaidTracker.L
	local r, g, b = RaidTracker:ColorToRGB(RaidTracker._options.Color)
	local sName,sLink,_,_,_,sClass,sSubClass = GetItemInfo("item:" .. item.id)
		
	if button == "LeftButton" then
		if IsModifiedClick("DRESSUP") and item.id then
			if sName then DressUpItemLink(sLink) end
			return true
		end
		if IsModifiedClick("CHATLINK") and item.c and item.id and item.name then
			if sName then 
				if type(WIM_API_InsertText) == "function" then
					WIM_API_InsertText(sLink)
				end
				ChatEdit_InsertLink(sLink)
			end
			return true
		end
		return false
    end

	local f = GameTooltip
	f:SetOwner(frame, "ANCHOR_BOTTOMRIGHT")
	if sName or button == "RightButton" then
		f:SetHyperlink("item:" .. item.id)
	else
		f:AddLine(item.name, RaidTracker:ColorToRGB(item.c))
		f:AddLine("This item is not in your cache, right-click to try to get the item.", 1, 1, 1, 1)
		f:AddLine("Warning: This may result in a disconnect!", 1, 0, 0)
	end
							f:AddLine(" ")
	if loot then
		if loot.time then	f:AddLine(RaidTracker:GetDisplayDate(loot.time), r, g, b); end
		if loot.zone then	f:AddLine(L[loot.zone], r, g, b)	end
		if loot.boss then	f:AddLine(L[loot.boss], r, g, b)	end
		if loot.costs then	f:AddLine(loot.costs, r, g, b) end
	end
	if item.class or sClass then	
							f:AddLine(L[item.class or sClass], r, g, b) end
	if (item.subclass or sSubClass) and (item.class or sClass) ~= (item.subclass or sSubClass) then
							f:AddLine(L[item.subclass or sSubClass], r, g, b) end
	f:Show()
	return button == "RightButton"
end

